<template>
  <div class="app-container">

    <!-- 搜索工作栏 -->
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="归属仓库" prop="warehouseId">
        <el-select v-model="queryParams.warehouseId" clearable>
            <el-option v-for="warehouse in warehouseList" :key="warehouse.id" :label="warehouse.titleZh" :value="warehouse.id" /> 
        </el-select>
      </el-form-item>
     
      <el-form-item label="区域编码" prop="regionCode">
        <el-input v-model="queryParams.regionCode" placeholder="请输入区域编码" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <!-- 操作工具栏 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
                   v-hasPermi="['ecw:shelf:create']">新增</el-button>
      </el-col>
      <!-- <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport" :loading="exportLoading"
                   v-hasPermi="['ecw:shelf:export']">导出</el-button>
      </el-col> -->
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <!-- 列表 -->
    <el-table v-loading="loading" :data="list">
      <el-table-column label="序号" type="index" width="50" />
      <el-table-column label="归属仓库" align="center" prop="warehouseId" >
        <template slot-scope="scope">
          <span>{{ warehouseName(scope.row.warehouseId) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="区域名称" align="center" prop="regionName" />
      <el-table-column label="区域编码" align="center" prop="regionCode" />
      <el-table-column label="条码起始号" align="center" prop="barcodeStart" />
      <el-table-column label="货架数量" align="center" prop="shelfNum" />
      <!-- <el-table-column label="货架起始号" align="center" prop="shelfStart" /> -->
      <el-table-column label="货架层数" align="center" prop="shelfLayer" />
      <!-- <el-table-column label="层数起始号" align="center" prop="layerStart" /> -->
      <el-table-column label="货架格数" align="center" prop="shelfGridNum" />
      <el-table-column label="货架类型" align="center" prop="shelfType">
        <template slot-scope="scope">
            <span>{{ shelfTypeName(scope.row.shelfType) }}</span>
          </template>
      </el-table-column>
      <!-- <el-table-column label="排序" align="center" prop="sort" /> -->
      <el-table-column label="状态" align="center" prop="status">
          <template slot-scope="scope">
            <span>{{ statusName(scope.row.status) }}</span>
          </template>
      </el-table-column>
      
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text" @click="toShelfGrid(scope.row)"
                     v-hasPermi="['ecw:shelf:query']">查看</el-button>
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
                     v-hasPermi="['ecw:shelf:update']">修改</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
                     v-hasPermi="['ecw:shelf:delete']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页组件 -->
    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNo" :limit.sync="queryParams.pageSize"
                @pagination="getList"/>

    <!-- 对话框(添加 / 修改) -->
    <el-dialog :title="title" :visible.sync="open" width="800px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="98px">

        <el-form-item label="归属仓库" prop="warehouseId">
          <el-select v-model="form.warehouseId" clearable>
            <el-option v-for="warehouse in warehouseList" :key="warehouse.id" :label="warehouse.titleZh" :value="warehouse.id" /> 
          </el-select>
        </el-form-item>  

        <el-form-item label="区域名称" prop="regionName">
          <el-col :span="8">
             <el-input v-model="form.regionName" placeholder="请输入区域名称"  />
          </el-col>
          <el-col :span="24">
             <span style="color:red;font-size:12px;">如：衣服区,电子区	货架名称格式为：货架分区-架位数-层数-格数 如：A区 第6货架 第5层 第1格：A-06-05-01</span>
          </el-col> 
        </el-form-item>

        <el-form-item label="区域编码" prop="regionCode">
          <el-col :span="8">
            <el-input v-model="form.regionCode" placeholder="请输入区域编码" />
          </el-col>
          
          <el-col :span="16">
             <span style="color:red;font-size:12px;">如：A B C</span>
          </el-col>
        </el-form-item>


        <el-form-item label="条码起始号" prop="barcodeStart">
          <el-col :span="8">
            <el-input v-model.number="form.barcodeStart" type="number" placeholder="请输入条码起始号" />
          </el-col>
          <el-col :span="16">
             <span style="color:red;font-size:12px;">货架条码：按起始号叠加，为4位数</span>
          </el-col>
        </el-form-item>


        <el-form-item label="货架数量" prop="shelfNum">
          <el-col :span="8">
            <el-input v-model.number="form.shelfNum" type="number" placeholder="请输入货架数量" />
          </el-col>
        </el-form-item>

        <el-form-item label="货架层数" prop="shelfLayer">
          <el-col :span="8">
            <el-input v-model.number="form.shelfLayer" type="number" placeholder="请输入货架层数" />
          </el-col>
        </el-form-item>

        <el-form-item label="货架格数" prop="shelfGridNum">
          <el-col :span="8">
            <el-input v-model.number="form.shelfGridNum" type="number" placeholder="请输入货架格数" />
          </el-col>
          <el-col :span="16">
             <span style="color:red;font-size:12px;">如果不分格子,则默认为一格	</span>
          </el-col>
        </el-form-item>


        <el-form-item label="货架类型" prop="shelfType">
          <el-radio-group v-model="form.shelfType">
                <el-radio v-for="shelfTypeItem in shelfTypeDatas" :key="shelfTypeItem.value" :label="parseInt(shelfTypeItem.value)">{{shelfTypeItem.label}}</el-radio>
          </el-radio-group>
        </el-form-item>

        <el-form-item label="状态" prop="status">
          <el-radio-group v-model="form.status">
            <el-radio v-for="statusItem in statusDictDatas" :key="statusItem.value" :label="parseInt(statusItem.value)">{{statusItem.value == CommonStatusEnum.ENABLE + '' ? '显示' : '不显示'}}</el-radio>
          </el-radio-group>
        </el-form-item>
        
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { createShelf, updateShelf, deleteShelf, getShelf, getShelfPage, exportShelfExcel } from "@/api/ecw/shelf";
import { getWarehouseList } from "@/api/ecw/warehouse"
import { getDictDatas, DICT_TYPE } from '@/utils/dict';
import {CommonStatusEnum} from '@/utils/constants'

export default {
  name: "Shelf",
  components: {
  },
  data() {
    return {
      //仓库列表
      warehouseList: [],
      shelfTypeDatas: getDictDatas(DICT_TYPE.ECW_SHELF_TYPE),
      CommonStatusEnum: CommonStatusEnum,
      statusDictDatas: getDictDatas(DICT_TYPE.COMMON_STATUS),

      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 货架列表
      list: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      dateRangeCreateTime: [],
      // 查询参数
      queryParams: {
        pageNo: 1,
        pageSize: 10,
        warehouseId: null,
        regionName: null,
        regionCode: null,
        barcodeStart: null,
        shelfNum: null,
        shelfStart: null,
        shelfLayer: null,
        layerStart: null,
        shelfGridNum: null,
        shelfType: null,
        sort: null,
        status: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        warehouseId: [{ required: true, message: "归属仓库不能为空", trigger: "blur" }],
        regionName: [{ required: true, message: "区域名称不能为空", trigger: "blur" }],
        regionCode: [{ required: true, message: "区域编码不能为空", trigger: "blur" }],
        barcodeStart: [{ required: true, message: "条码起始号不能为空", trigger: "blur" }],
        shelfNum: [{ required: true, message: "货架数量不能为空", trigger: "blur" }],
        shelfLayer: [{ required: true, message: "货架层数不能为空", trigger: "blur" }],
        shelfType: [{ required: true, message: "货架类型不能为空", trigger: "blur" }],
      }
    };
  },

  computed: {
    warehouseName() {
      return warehouseId => {
        for(let index in this.warehouseList) {
          let warehouseItem = this.warehouseList[index];
          if(warehouseItem.id == warehouseId) {
            return warehouseItem.titleZh;
          }
        }
      }
    },

    statusName() {
      return value => {
        for(let index in this.statusDictDatas) {
          let dictItem = this.statusDictDatas[index];
          if(dictItem.value == value) {
            return dictItem.value == CommonStatusEnum.ENABLE + '' ? '显示' : '不显示';
          }
        }
      }
    },

    shelfTypeName() {
      return value => {
        for(let index in this.shelfTypeDatas) {
          let dictItem = this.shelfTypeDatas[index];
          if(dictItem.value == value) {
            return dictItem.label;
          }
        }
      }
    },
  },

  created() {
    this.requestWarehouseList();
    this.getList();
  },
  methods: {
    toShelfGrid(row) {
        this.$router.push({
          path:'/shelf/grid',
          query: {
            shelfId:row.id,
            warehouseName:this.warehouseName(row.warehouseId)
          }
        })
    },

    /**查询仓库 */
    requestWarehouseList() {
      getWarehouseList({}).then(response => {
        this.warehouseList = response.data;
      })
    },

    /** 查询列表 */
    getList() {
      this.loading = true;
      // 处理查询参数
      let params = {...this.queryParams};
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, 'createTime');
      // 执行查询
      getShelfPage(params).then(response => {
        this.list = response.data.list;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    /** 取消按钮 */
    cancel() {
      this.open = false;
      this.reset();
    },
    /** 表单重置 */
    reset() {
      this.form = {
        id: undefined,
        warehouseId: undefined,
        regionName: undefined,
        regionCode: undefined,
        barcodeStart: undefined,
        shelfNum: undefined,
        shelfStart: undefined,
        shelfLayer: undefined,
        layerStart: undefined,
        shelfGridNum: undefined,
        shelfType: undefined,
        sort: undefined,
        status: undefined,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRangeCreateTime = [];
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加货架";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id;
      getShelf(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改货架";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (!valid) {
          return;
        }
        // 修改的提交
        if (this.form.id != null) {
          updateShelf(this.form).then(response => {
            this.$modal.msgSuccess("修改成功");
            this.open = false;
            this.getList();
          });
          return;
        }
        // 添加的提交
        createShelf(this.form).then(response => {
          this.$modal.msgSuccess("新增成功");
          this.open = false;
          this.getList();
        });
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const id = row.id;
      this.$modal.confirm('是否确认删除货架编号为"' + id + '"的数据项?').then(function() {
          return deleteShelf(id);
        }).then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      // 处理查询参数
      let params = {...this.queryParams};
      params.pageNo = undefined;
      params.pageSize = undefined;
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, 'createTime');
      // 执行导出
      this.$modal.confirm('是否确认导出所有货架数据项?').then(() => {
          this.exportLoading = true;
          return exportShelfExcel(params);
        }).then(response => {
          this.$download.excel(response, '${table.classComment}.xls');
          this.exportLoading = false;
        }).catch(() => {});
    }
  }
};
</script>
